package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import java.util.HashMap;
import java.util.Set;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;

/**
 * Implements a simple attribute container for use as delegate
 */
public class AttributeContainer implements IContainAttribute {
	private HashMap<AttributeType, Object> attributes = new HashMap<AttributeType,Object>();
	
	//nur bis niemand mehr die deprecated Methoden nutzt
	private static final HashMap<String, AttributeType> ATTRIBUTE_MAP = new HashMap<String, AttributeType>();
	static {
		ATTRIBUTE_MAP.put("cost", AttributeType.COST);
		ATTRIBUTE_MAP.put("time", AttributeType.TIME);
		ATTRIBUTE_MAP.put("reliability", AttributeType.RELIABILITY);
		ATTRIBUTE_MAP.put("probability", AttributeType.PROBABILITY);
		ATTRIBUTE_MAP.put("N-out-of-M", AttributeType.N_OUT_OF_M);
		ATTRIBUTE_MAP.put("BflowId", AttributeType.BFLOW_ID);
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public Set<AttributeType> getAttributeKeys() {
		return attributes.keySet();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void addAttribute(AttributeType type, Object value) {
		attributes.put(type, value);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void setAttribute(AttributeType type, Object value) {
		addAttribute(type, value);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Object getAttribute(AttributeType type) {
		return attributes.get(type);
	}

	@Override
	public boolean hasAttribute(AttributeType type) {
		return attributes.containsKey(type);
	}

}
