package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import java.util.Set;

import org.jbpt.pm.Event;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;

/**
 * Base class for all model elements in a {@link IProcessModel} representing an event with attributes.
 * 
 * @author Anne Fischer
 */
public class CustomEvent extends Event implements IContainAttribute {
	private IContainAttribute attributes = new AttributeContainer();

	public CustomEvent() {
		super();
	}

	public CustomEvent(String name) {
		super(name);
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public Set<AttributeType> getAttributeKeys() {
		return attributes.getAttributeKeys();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void addAttribute(AttributeType type, Object value) {
		attributes.addAttribute(type, value);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void setAttribute(AttributeType type, Object value) {
		attributes.setAttribute(type, value);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Object getAttribute(AttributeType type) {
		return attributes.getAttribute(type);
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean hasAttribute(AttributeType type) {
		return attributes.hasAttribute(type);
	}
}
