package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import java.util.Set;

import org.jbpt.pm.epc.Function;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;

/**
 * Class for EPC Function with attributes
 * 
 * @author Anne Fischer
 *
 */

public class CustomFunction extends Function implements IContainAttribute {
	private IContainAttribute attributes = new AttributeContainer();
	
	public CustomFunction() {
		super();
	}

	public CustomFunction(String name) {
		super(name);	
	}

	public CustomFunction(String name, String description) {
		super(name, description);
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public Set<AttributeType> getAttributeKeys() {
		return attributes.getAttributeKeys();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void addAttribute(AttributeType type, Object value) {
		attributes.addAttribute(type, value);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void setAttribute(AttributeType type, Object value) {
		attributes.setAttribute(type, value);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Object getAttribute(AttributeType type) {
		return attributes.getAttribute(type);
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean hasAttribute(AttributeType type) {
		return attributes.hasAttribute(type);
	}
}
