package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import java.util.Set;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;

/**
 * This interface define the methods needed for the use of attributes in EPK elements
 * 
 * @author Anne Fischer
 */
public interface IContainAttribute {
	/**
	 * Add an attribute to the attribute HashMap of an element
	 * 
	 * @param type type identifier for the attribute
	 * @param value
	 */
	public void addAttribute(AttributeType type, Object value);

	/**
	 * Change the value of an attribute
	 * 
	 * @param type type identifier for the attribute
	 * @param value - the value of an attribute
	 */
	public void setAttribute(AttributeType type, Object value);
	
	/**
	 * Returns the value of an attribute
	 * 
	 * @param type type identifier for the attribute
	 * @return the value of an attribute
	 */
	public Object getAttribute(AttributeType type);
	
	/**
	 * Returns whether an attribute is set for the element or not
	 * 
	 * @param type type identifier for the attribute
	 * @return true: attribute is set, false: else
	 */
	public boolean hasAttribute(AttributeType type);
	
	/**
	 * Returns a Set of attribute types set.
	 * @return
	 */
	public Set<AttributeType> getAttributeKeys();
}
