package de.fh_zwickau.bumb_l_b.qos_tool.loader;

public class EpcLoaderException extends Exception {
	private static final long serialVersionUID = 1L;
	private String elementReference = "";
	
	/**
	 * Creates a new EpcLoaderException
	 */
	public EpcLoaderException() {
		super();
	}
	
	/**
	 * Creates a new EpcLoaderException with the given message
	 * @param message
	 */
	public EpcLoaderException(String message) {
		super(message);
	}

	/**
	 * Creates a new EpcLoaderException with the given message an reference
	 * @param message
	 * @param elementReference
	 */
	public EpcLoaderException(String message, String elementReference) {
		this(message);
		this.elementReference = elementReference;
	}

	/**
	 * Returns a string for identifying the epc element this exception is related to.
	 * @return
	 */
	public String getElementReference() {
		return elementReference;
	}
	
	@Override
	public String toString() {
		return super.toString()+", reference:"+elementReference;
	}
}
