package de.fh_zwickau.bumb_l_b.qos_tool.loader;

import java.io.File;

import org.jbpt.pm.ControlFlow;
import org.jbpt.pm.FlowNode;
import org.jbpt.pm.NonFlowNode;
import org.jbpt.pm.epc.IEpc;

public interface IEpcLoader {

	/**
	 * Creates an epc model based on the data stored in a file.
	 * @param file file object
	 * @return first epc model
	 * @throws EpcLoaderException
	 */
	public IEpc<ControlFlow<FlowNode>, FlowNode, NonFlowNode> loadFile(File file) throws EpcLoaderException;
	
	/**
	 * Creates an epc model based on the data stored in a file.
	 * @param filename filename to load
	 * @return first epc model
	 * @throws EpcLoaderException
	 */
	public IEpc<ControlFlow<FlowNode>, FlowNode, NonFlowNode> loadFile(String filename) throws EpcLoaderException;
	
	/**
	 * Creates an epc model based on a given String.
	 * @param epcString String to interpret
	 * @return first epc model
	 * @throws EpcLoaderException
	 */
	public IEpc<ControlFlow<FlowNode>, FlowNode, NonFlowNode> loadString(String epcString) throws EpcLoaderException; 
}
