package de.fh_zwickau.bumb_l_b.qos_tool.printer;

/**
 * Implements a printer for bflow problems view output format.
 * @author Christian Fiedler, Mathias Grunert
 */
public class BflowPrinter extends AbstractPrinter {
	private static BflowPrinter instance;

	/**
	 * Constructor for use in factory method.
	 */
	private BflowPrinter() { }
	
	/**
	 * {@inheritDoc}
	 */
	public synchronized static BflowPrinter getInstance() {
		if(instance == null) {
			instance = new BflowPrinter();
		}
		return instance;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void printMessage(MsgType type, String message, String elementId) {
		//Hier kann ggf. noch eine Ersetzung moeglicher Zeilenumbrueche erfolgen
		//ggf. vorherigen Zeilenumbruch, um Nachrichtenblock wirklich spearat zu haben
		getPrintStream().println(
			"addon:[MESSAGE]["
			+ type + "]["
			+ elementId + "]["
			+ message
			+ "][]#FS#"
		);
	}	
	
}
