package de.fh_zwickau.bumb_l_b.qos_tool.printer;

import de.fh_zwickau.bumb_l_b.qos_tool.Message;

/**
 * Implements a simple default printer for human readable messages.
 * @author Christian Fiedler
 */
public class DefaultPrinter extends AbstractPrinter {
	private static DefaultPrinter instance;

	/**
	 * Constructor for use in factory method.
	 */
	private DefaultPrinter() { }
	
	/**
	 * {@inheritDoc}
	 */
	public synchronized static DefaultPrinter getInstance() {
		if(instance == null) {
			instance = new DefaultPrinter();
		}
		return instance;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void printMessage(MsgType type, String message, String elementId) {
		String output = type+": "+message;
		if(elementId != null && elementId.length()>0) { output += " ("+String.format(Message.get("printer.related_element"), elementId)+")"; }
		getPrintStream().println(output);
	}

	
}
