package de.fh_zwickau.bumb_l_b.qos_tool.printer;

/**
 * Interface for printers
 * @author Anne Fischer, Christian Fiedler
 */
public interface IPrinter {
	/**
	 * Print msg as an error.
	 * @param msg
	 */
	public void printError(String msg);
	
	/**
	 * Print msg as a warning.
	 * @param msg
	 */
	public void printWarning(String msg);
	
	/**
	 * Print msg as an info.
	 * @param msg
	 */
	public void printInfo(String msg);
	
	/**
	 * Print msg as an error relating to an element id.
	 * @param msg
	 * @param elementId
	 */
	public void printError(String msg, String elementId);
	
	/**
	 * Print msg as a warning relating to an element id.
	 * @param msg
	 * @param elementId
	 */
	public void printWarning(String msg, String elementId);
	
	/**
	 * Print msg as an info relating to an element id.
	 * @param msg
	 * @param elementId
	 */
	public void printInfo(String msg, String elementId);
}
