package de.fh_zwickau.bumb_l_b.qos_tool.printer;

/**
 * Implements a static factory for creating printer instances.
 * @author Christian Fiedler
 */
public class StaticPrinterFactory {
	/** Defines printer types */
	public enum PrinterType {
		DEFAULT,
		BFLOW
	}
	
	/**
	 * Returns a printer instance of the given type
	 * @param type
	 * @return
	 */
	public static IPrinter getPrinterInstance(PrinterType type) {
		IPrinter printer;
		
		if(type==null) { type = PrinterType.DEFAULT; }
		
		switch(type) {
		case BFLOW:
			printer = BflowPrinter.getInstance();
			break;
		case DEFAULT:
		default:
			printer = DefaultPrinter.getInstance();
		}
		
		return printer;
	}
}
