package de.fh_zwickau.bumb_l_b.qos_tool.processor;

import org.jbpt.hypergraph.abs.Vertex;

/**
 * Exception for problems in qos attribute calculation
 */
public class ReplacementException extends Exception {
	private Vertex affectedNode;
	
	public ReplacementException(String message, Throwable cause) {
		super(message, cause);
	}

	public ReplacementException(String message) {
		super(message);
	}

	public ReplacementException(Throwable cause) {
		super(cause);
	}
	
	public ReplacementException(String message, Throwable cause, Vertex affectedNode) {
		super(message, cause);
		this.setAffectedNode(affectedNode);
	}
	
	public ReplacementException(String message, Vertex affectedNode) {
		super(message);
		this.setAffectedNode(affectedNode);
	}
	
	public ReplacementException(Throwable cause, Vertex affectedNode) {
		super(cause);
		this.setAffectedNode(affectedNode);
	}

	public Vertex getAffectedNode() {
		return affectedNode;
	}

	public void setAffectedNode(Vertex affectedNode) {
		this.affectedNode = affectedNode;
	}
}
