package de.fh_zwickau.bumb_l_b.qos_tool.verifier;

import java.util.Set;

import org.jbpt.pm.ControlFlow;
import org.jbpt.pm.FlowNode;
import org.jbpt.pm.NonFlowNode;
import org.jbpt.pm.epc.IEpc;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;

public interface IEpcVerifier {
	/**
	 * Verifies that an epc is processable at all an does not contain fatal contradictions
	 * @param epc
	 * @return true: epc is processable, false: else
	 */
	public boolean verify(IEpc<ControlFlow<FlowNode>, FlowNode, NonFlowNode> epc);
	
	/**
	 * Returns a set containing attribute types that are recognized as appropriate for qos processing in the last verified epc.
	 * @return
	 */
	public Set<AttributeType> getProcessableAttributeTypes();
}
