package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;
import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.CustomAndConnector;

public class TestCustomAndConnector {

	private CustomAndConnector andConnector;
	
	@Before
	public void setUp() throws Exception {
		andConnector = new CustomAndConnector("AndJoin 1");
	}

	@Test
	public void testAddAttribute() {
		andConnector.addAttribute(AttributeType.N_OUT_OF_M, 1);
		assertEquals(1, andConnector.getAttribute(AttributeType.N_OUT_OF_M));
	}
	
	@Test
	public void testSetAttribute() {
		andConnector.addAttribute(AttributeType.N_OUT_OF_M, 1);
		assertEquals(1, andConnector.getAttribute(AttributeType.N_OUT_OF_M));	
		
		andConnector.setAttribute(AttributeType.N_OUT_OF_M, 3);
		assertEquals(3, andConnector.getAttribute(AttributeType.N_OUT_OF_M));
	}
	
	@Test
	public void testAddAttributeValueIsNull() {
		andConnector.addAttribute(AttributeType.N_OUT_OF_M, null);
		assertEquals(null, andConnector.getAttribute(AttributeType.N_OUT_OF_M));	
	}

}
