package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import static org.junit.Assert.*;

import org.jbpt.pm.IFlowNode;
import org.junit.Before;
import org.junit.Test;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;
import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.CustomControlFlow;

public class TestCustomControlFlow {

	private CustomControlFlow<IFlowNode> customControlFlow;
	
	@Before
	public void setUp() throws Exception {
		customControlFlow = new CustomControlFlow<IFlowNode>(null, null, null);
	}

	@Test
	public void testAddAttribute() {
		customControlFlow.addAttribute(AttributeType.PROBABILITY, 0.1);
		assertEquals(0.1, customControlFlow.getAttribute(AttributeType.PROBABILITY));
	}
	
	@Test
	public void testSetAttribute() {
		customControlFlow.addAttribute(AttributeType.PROBABILITY, 0.1);
		assertEquals(0.1, customControlFlow.getAttribute(AttributeType.PROBABILITY));	
		
		customControlFlow.setAttribute(AttributeType.PROBABILITY, 0.3);
		assertEquals(0.3, customControlFlow.getAttribute(AttributeType.PROBABILITY));
	}
	
	@Test
	public void testAddAttributeValueIsNull() {
		customControlFlow.addAttribute(AttributeType.PROBABILITY, null);
		assertEquals(null, customControlFlow.getAttribute(AttributeType.PROBABILITY));	
	}

}
