package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;
import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.CustomEvent;

public class TestCustomEvent {

	private CustomEvent event1;
	
	@Before
	public void setUp() throws Exception {
		event1 = new CustomEvent("Event1");
	}

	@Test
	public void testAddAttribute() {
		event1.addAttribute(AttributeType.PROBABILITY, 0.80);
		assertEquals(0.80, event1.getAttribute(AttributeType.PROBABILITY));
	}
	
	@Test
	public void testSetAttribute() {
		event1.addAttribute(AttributeType.PROBABILITY, 0.80);
		assertEquals(0.80, event1.getAttribute(AttributeType.PROBABILITY));	
		
		event1.setAttribute(AttributeType.PROBABILITY, 0.95);
		assertEquals(0.95, event1.getAttribute(AttributeType.PROBABILITY));
	}
	
	@Test
	public void testAddAttributeValueIsNull() {
		event1.addAttribute(AttributeType.PROBABILITY, null);
		assertEquals(null, event1.getAttribute(AttributeType.PROBABILITY));	
	}

}
