package de.fh_zwickau.bumb_l_b.qos_tool.customJBPT;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.AttributeHelper.AttributeType;
import de.fh_zwickau.bumb_l_b.qos_tool.customJBPT.CustomFunction;

public class TestFunction {

	private CustomFunction function1;
	
	@Before
	public void setUp() throws Exception {
		function1 = new CustomFunction("Function 1");
	}

	@Test
	public void testAddAttribute() {
		function1.addAttribute(AttributeType.COST, 10);
		function1.addAttribute(AttributeType.TIME, 24);
		function1.addAttribute(AttributeType.RELIABILITY, 0.8);
		assertEquals(10, function1.getAttribute(AttributeType.COST));
		assertEquals(24, function1.getAttribute(AttributeType.TIME));
		assertEquals(0.80, function1.getAttribute(AttributeType.RELIABILITY));
	}
	
	@Test
	public void testSetAttribute() {
		function1.addAttribute(AttributeType.COST, 10);
		function1.addAttribute(AttributeType.TIME, 24);
		function1.addAttribute(AttributeType.RELIABILITY, 0.80);
		assertEquals(0.80, function1.getAttribute(AttributeType.RELIABILITY));	
		
		function1.setAttribute(AttributeType.RELIABILITY, 0.95);
		assertEquals(0.95, function1.getAttribute(AttributeType.RELIABILITY));
		assertEquals(10, function1.getAttribute(AttributeType.COST));
		assertEquals(24, function1.getAttribute(AttributeType.TIME));
	}
	
	@Test
	public void testAddAttributeValueIsNull() {
		function1.addAttribute(AttributeType.RELIABILITY, null);
		assertEquals(null, function1.getAttribute(AttributeType.RELIABILITY));	
	}
}
